﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace XamGridCustomConditionalFormat
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            List<Data> data = new List<Data>();
            for (int i = 0; i < 25; i++)
            {
                Data d = new Data() { Name = "Person " + i, Value = i % 5 };
                data.Add(d);
            }
            grid.ItemsSource = data;
        }

    }

        public class Data
        {
            public string Name { get; set; }
            public double Value { get; set; }
        }

        public class MyConditionalFormatRule : ConditionalFormattingRuleBase
        {
            protected override IConditionalFormattingRuleProxy CreateProxy()
            {
                return new MyConditionalFormatRuleProxy();
            }


        }

        public class MyConditionalFormatRuleProxy : ConditionalFormattingRuleBaseProxy
        {
            private Style RedStyle { get; set; }
            private Style YellowStyle { get; set; }

            public MyConditionalFormatRuleProxy()
            {
                Style redStyle = new Style(typeof(ConditionalFormattingCellControl));
                redStyle.Setters.Add(new Setter() { Property = ConditionalFormattingCellControl.BackgroundProperty, Value = new SolidColorBrush(Colors.Red) });
                redStyle.Setters.Add(new Setter() { Property = ConditionalFormattingCellControl.AltBackgroundProperty, Value = new SolidColorBrush(Colors.Red) });
                this.RedStyle = redStyle;

                Style yellowStyle = new Style(typeof(ConditionalFormattingCellControl));
                yellowStyle.Setters.Add(new Setter() { Property = ConditionalFormattingCellControl.BackgroundProperty, Value = new SolidColorBrush(Colors.Yellow) });
                yellowStyle.Setters.Add(new Setter() { Property = ConditionalFormattingCellControl.AltBackgroundProperty, Value = new SolidColorBrush(Colors.Yellow) });

                this.YellowStyle = yellowStyle;
            }

            protected override Style EvaluateCondition(object sourceDataObject, object sourceDataValue)
            {
                Data d = (Data)sourceDataObject;
                if (d.Value == 3.0)
                    return this.YellowStyle;
                if (d.Value > 3)
                    return this.RedStyle;

                return null;  // leave it unstyled;

            }
        
    }
}
